import 'dart:async';

import 'package:analyzer/dart/element/element.dart';
import 'package:source_gen/source_gen.dart';
import 'package:dao_wrapped_annotation/dao_wrapped_annotation.dart';
import 'src/create_table.dart';

class DaoTableGenerator extends GeneratorForAnnotation<DaoTable> {
  @override
  FutureOr<String> generateForAnnotatedElement(
      Element element, ConstantReader annotation, buildStep) {
    var tableOut = "";
    try {
      final annotationValue = annotation.objectValue;

      final model = annotationValue.getField("model").toTypeValue();

      final primaryKey = annotationValue.getField("primaryKey").toStringValue();

      tableOut += CreateTable().create(model, primaryKey);
    } catch (e) {
      print("error: $e \n");
    }
    return tableOut;
  }
}
